 
const char *GridVert = 
"#version 330 core\n"
"layout (location = 0) in vec3 aPos;\n"
"uniform mat4 modelView;\n"
"uniform mat4 projection;\n"
"out vec3 near;\n"
"out vec3 far;\n"
"out vec3 center;\n"
"out mat4 model;\n"
"out mat4 proj;\n"
"void main()\n"
"{\n"
"    mat4 invProj = inverse(projection);\n"
"    mat4 invModelView = inverse(modelView);\n"
"    vec4 near4 = invModelView*invProj*vec4(aPos.x, aPos.y, 0.0, 1.0);\n"
"    if (near4.w!=0) {near4.xyz /= near4.w;}\n"
"    vec4 far4 = invModelView*invProj*vec4(aPos.x, aPos.y, 1.0, 1.0);\n"
"    if (far4.w!=0) {far4.xyz /= far4.w;}\n"
"    // The projection is done in the fragment code\n"
"    gl_Position = vec4(aPos, 1.0);\n"
"    model = modelView;\n"
"    proj = projection;\n"
"    near = near4.xyz;\n"
"    far = far4.xyz;\n"
"}\n"
;
